local _G = GLOBAL
local require = GLOBAL.require
local TargetIndicator = require "widgets/targetindicator"
require "prefabutil"
local SERVER_SIDE = _G.TheNet:GetIsServer()

local function FOverride1(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self, target)
        return false
    end
end

local function FOverride2(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self, target)
        return true
    end
end

local function FOverride3(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self)
    end
end

local function FOverride4(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self)
        --[[if not GLOBAL.TheNet:IsDedicated() then
            local present = { }
            for i, v in ipairs(self.offScreenPlayers) do
                present[v] = true
            end

            if GLOBAL.ThePlayer.Net_player1_name:value() ~= "" and GLOBAL.ThePlayer.Net_player1_name:value() ~= self.inst.name then
                if not(present[GLOBAL.ThePlayer.Net_player1_name:value()]) then
                    self.inst.HUD:AddTargetIndicator(GLOBAL.ThePlayer.Net_player1_x:value(), GLOBAL.ThePlayer.Net_player1_z:value(), GLOBAL.ThePlayer.Net_player1_name:value())
                    print(GLOBAL.ThePlayer.Net_player1_name:value() .. ":" .. self.inst.name)
                    table.insert(self.offScreenPlayers, GLOBAL.ThePlayer.Net_player1_name:value())
                end
            end

            if GLOBAL.ThePlayer.Net_player2_name:value() ~= "" and GLOBAL.ThePlayer.Net_player2_name:value() ~= self.inst.name then
                if not(present[GLOBAL.ThePlayer.Net_player2_name:value()]) then
                    self.inst.HUD:AddTargetIndicator(GLOBAL.ThePlayer.Net_player2_x:value(), GLOBAL.ThePlayer.Net_player2_z:value(), GLOBAL.ThePlayer.Net_player2_name:value())
                    print(GLOBAL.ThePlayer.Net_player2_name:value() .. ":" .. self.inst.name)
                    table.insert(self.offScreenPlayers, GLOBAL.ThePlayer.Net_player2_name:value())
                end
            end

            if GLOBAL.ThePlayer.Net_player3_name:value() ~= "" and GLOBAL.ThePlayer.Net_player3_name:value() ~= self.inst.name then
                if not(present[GLOBAL.ThePlayer.Net_player3_name:value()]) then
                    self.inst.HUD:AddTargetIndicator(GLOBAL.ThePlayer.Net_player3_x:value(), GLOBAL.ThePlayer.Net_player3_z:value(), GLOBAL.ThePlayer.Net_player3_name:value())
                    print(GLOBAL.ThePlayer.Net_player3_name:value() .. ":" .. self.inst.name)
                    table.insert(self.offScreenPlayers, GLOBAL.ThePlayer.Net_player3_name:value())
                end
            end

            if GLOBAL.ThePlayer.Net_player4_name:value() ~= "" and GLOBAL.ThePlayer.Net_player4_name:value() ~= self.inst.name then
                if not(present[GLOBAL.ThePlayer.Net_player4_name:value()]) then
                    self.inst.HUD:AddTargetIndicator(GLOBAL.ThePlayer.Net_player4_x:value(), GLOBAL.ThePlayer.Net_player4_z:value(), GLOBAL.ThePlayer.Net_player4_name:value())
                    print(GLOBAL.ThePlayer.Net_player4_name:value() .. ":" .. self.inst.name)
                    table.insert(self.offScreenPlayers, GLOBAL.ThePlayer.Net_player4_name:value())
                end
            end

            if GLOBAL.ThePlayer.Net_player5_name:value() ~= "" and GLOBAL.ThePlayer.Net_player5_name:value() ~= self.inst.name then
                if not(present[GLOBAL.ThePlayer.Net_player5_name:value()]) then
                    self.inst.HUD:AddTargetIndicator(GLOBAL.ThePlayer.Net_player5_x:value(), GLOBAL.ThePlayer.Net_player5_z:value(), GLOBAL.ThePlayer.Net_player5_name:value())
                    print(GLOBAL.ThePlayer.Net_player5_name:value() .. ":" .. self.inst.name)
                    table.insert(self.offScreenPlayers, GLOBAL.ThePlayer.Net_player5_name:value())
                end
            end

            if GLOBAL.ThePlayer.Net_player6_name:value() ~= "" and GLOBAL.ThePlayer.Net_player6_name:value() ~= self.inst.name then
                if not(present[GLOBAL.ThePlayer.Net_player6_name:value()]) then
                    self.inst.HUD:AddTargetIndicator(GLOBAL.ThePlayer.Net_player6_x:value(), GLOBAL.ThePlayer.Net_player6_z:value(), GLOBAL.ThePlayer.Net_player6_name:value())
                    print(GLOBAL.ThePlayer.Net_player6_name:value() .. ":" .. self.inst.name)
                    table.insert(self.offScreenPlayers, GLOBAL.ThePlayer.Net_player6_name:value())
                end
            end

            if not self.inst.HUD.targetindicators then
                return
            end

            local leftPlayer = { }

            for i, v in ipairs(self.inst.HUD.targetindicators) do
                if v.name == GLOBAL.ThePlayer.Net_player1_name:value() then
                    self.inst.HUD.targetindicators[i].pos_x = GLOBAL.ThePlayer.Net_player1_x:value()
                    self.inst.HUD.targetindicators[i].pos_z = GLOBAL.ThePlayer.Net_player1_z:value()

                    local x, y, z = self.inst.Transform:GetWorldPosition()
                    local dist =(x - GLOBAL.ThePlayer.Net_player1_x:value()) ^ 2 +(z - GLOBAL.ThePlayer.Net_player1_z:value()) ^ 2
                    dist = math.sqrt(dist)

                    if dist < 20 then
                        self.inst.HUD.targetindicators[i]:Hide()
                    else
                        self.inst.HUD.targetindicators[i]:Show()
                    end

                elseif v.name == GLOBAL.ThePlayer.Net_player2_name:value() then
                    self.inst.HUD.targetindicators[i].pos_x = GLOBAL.ThePlayer.Net_player2_x:value()
                    self.inst.HUD.targetindicators[i].pos_z = GLOBAL.ThePlayer.Net_player2_z:value()

                    local x, y, z = self.inst.Transform:GetWorldPosition()
                    local dist =(x - GLOBAL.ThePlayer.Net_player2_x:value()) ^ 2 +(z - GLOBAL.ThePlayer.Net_player2_z:value()) ^ 2
                    dist = math.sqrt(dist)

                    if dist < 20 then
                        self.inst.HUD.targetindicators[i]:Hide()
                    else
                        self.inst.HUD.targetindicators[i]:Show()
                    end

                elseif v.name == GLOBAL.ThePlayer.Net_player3_name:value() then
                    self.inst.HUD.targetindicators[i].pos_x = GLOBAL.ThePlayer.Net_player3_x:value()
                    self.inst.HUD.targetindicators[i].pos_z = GLOBAL.ThePlayer.Net_player3_z:value()

                    local x, y, z = self.inst.Transform:GetWorldPosition()
                    local dist =(x - GLOBAL.ThePlayer.Net_player3_x:value()) ^ 2 +(z - GLOBAL.ThePlayer.Net_player3_z:value()) ^ 2
                    dist = math.sqrt(dist)

                    if dist < 20 then
                        self.inst.HUD.targetindicators[i]:Hide()
                    else
                        self.inst.HUD.targetindicators[i]:Show()
                    end

                elseif v.name == GLOBAL.ThePlayer.Net_player4_name:value() then
                    self.inst.HUD.targetindicators[i].pos_x = GLOBAL.ThePlayer.Net_player4_x:value()
                    self.inst.HUD.targetindicators[i].pos_z = GLOBAL.ThePlayer.Net_player4_z:value()

                    local x, y, z = self.inst.Transform:GetWorldPosition()
                    local dist =(x - GLOBAL.ThePlayer.Net_player4_x:value()) ^ 2 +(z - GLOBAL.ThePlayer.Net_player4_z:value()) ^ 2
                    dist = math.sqrt(dist)

                    if dist < 20 then
                        self.inst.HUD.targetindicators[i]:Hide()
                    else
                        self.inst.HUD.targetindicators[i]:Show()
                    end

                elseif v.name == GLOBAL.ThePlayer.Net_player5_name:value() then
                    self.inst.HUD.targetindicators[i].pos_x = GLOBAL.ThePlayer.Net_player5_x:value()
                    self.inst.HUD.targetindicators[i].pos_z = GLOBAL.ThePlayer.Net_player5_z:value()

                    local x, y, z = self.inst.Transform:GetWorldPosition()
                    local dist =(x - GLOBAL.ThePlayer.Net_player5_x:value()) ^ 2 +(z - GLOBAL.ThePlayer.Net_player5_z:value()) ^ 2
                    dist = math.sqrt(dist)

                    if dist < 20 then
                        self.inst.HUD.targetindicators[i]:Hide()
                    else
                        self.inst.HUD.targetindicators[i]:Show()
                    end

                elseif v.name == GLOBAL.ThePlayer.Net_player6_name:value() then
                    self.inst.HUD.targetindicators[i].pos_x = GLOBAL.ThePlayer.Net_player6_x:value()
                    self.inst.HUD.targetindicators[i].pos_z = GLOBAL.ThePlayer.Net_player6_z:value()

                    local x, y, z = self.inst.Transform:GetWorldPosition()
                    local dist =(x - GLOBAL.ThePlayer.Net_player6_x:value()) ^ 2 +(z - GLOBAL.ThePlayer.Net_player6_z:value()) ^ 2
                    dist = math.sqrt(dist)

                    if dist < 20 then
                        self.inst.HUD.targetindicators[i]:Hide()
                    else
                        self.inst.HUD.targetindicators[i]:Show()
                    end
                end
            end
        end]]
    end
end


local function FOverride5(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self, x, z, name)
        if not self.targetindicators then
            self.targetindicators = { }
        end

        local ti = self.under_root:AddChild(TargetIndicator(self.owner, x, z, name))
        table.insert(self.targetindicators, ti)
    end
end

local function FOverride6(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self, name)
        if not self.targetindicators then return end

        for i, v in pairs(self.targetindicators) do
            if v and v:GetTarget() == name then
                return true
            end
        end
        return false
    end
end

local function FOverride7(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self, target)
        if not self.targetindicators then return end
		print("CHECK TRUE")
        local index = nil
        for i, v in pairs(self.targetindicators) do
			print("CHECK : "..v:GetTarget()..":"..target)
            if v and v:GetTarget() == target then
                index = i
                break
            end
        end
        if index then
            local ti = table.remove(self.targetindicators, index)
            if ti then ti:Kill() end
        end
    end
end

local function FOverride8(comp, fn_name, fn)
    local old_fn = comp[fn_name]
    comp[fn_name] = function(self, player)
	print("THE FUCK2")
        for i, v in ipairs(self.offScreenPlayers) do
			print(v..":"..player.name)
            if v == player.name then
                self.inst.HUD:RemoveTargetIndicator(v)
                table.remove(self.offScreenPlayers, i)
                break
            end
        end
    end
end

local PTI = require "components/playertargetindicator"
local PHUD = require "screens/playerhud"
--FOverride1(PTI, "ShouldRemoveIndicator", function(self, target) end)
--FOverride2(PTI, "ShouldShowIndicator", function(self, target) end)
--FOverride3(PTI, "OnRemoveFromEntity", function(self) end)
--FOverride4(PTI, "OnUpdate", function(self) end)
FOverride5(PHUD, "AddTargetIndicator", function(self, x, y, name, avatar) end)
FOverride6(PHUD, "HasTargetIndicator", function(self, name) end)
FOverride7(PHUD, "RemoveTargetIndicator", function(self, target) end)
--FOverride8(PTI, "OnPlayerExited", function(self, player) end)

local function PPPostInit(inst)
    inst.Net_player1_name = GLOBAL.net_string(inst.GUID, "player1_name", "")
    inst.Net_player2_name = GLOBAL.net_string(inst.GUID, "player2_name", "")
    inst.Net_player3_name = GLOBAL.net_string(inst.GUID, "player3_name", "")
    inst.Net_player4_name = GLOBAL.net_string(inst.GUID, "player4_name", "")
    inst.Net_player5_name = GLOBAL.net_string(inst.GUID, "player5_name", "")
    inst.Net_player6_name = GLOBAL.net_string(inst.GUID, "player6_name", "")

    inst.Net_player1_x = GLOBAL.net_float(inst.GUID, "player1_x", "")
    inst.Net_player1_z = GLOBAL.net_float(inst.GUID, "player1_z", "")

    inst.Net_player2_x = GLOBAL.net_float(inst.GUID, "player2_x", "")
    inst.Net_player2_z = GLOBAL.net_float(inst.GUID, "player2_z", "")

    inst.Net_player3_x = GLOBAL.net_float(inst.GUID, "player3_x", "")
    inst.Net_player3_z = GLOBAL.net_float(inst.GUID, "player3_z", "")

    inst.Net_player4_x = GLOBAL.net_float(inst.GUID, "player4_x", "")
    inst.Net_player4_z = GLOBAL.net_float(inst.GUID, "player4_z", "")

    inst.Net_player5_x = GLOBAL.net_float(inst.GUID, "player5_x", "")
    inst.Net_player5_z = GLOBAL.net_float(inst.GUID, "player5_z", "")

    inst.Net_player6_x = GLOBAL.net_float(inst.GUID, "player6_x", "")
    inst.Net_player6_z = GLOBAL.net_float(inst.GUID, "player6_z", "")

    if GLOBAL.TheWorld.ismastersim then
        inst:DoPeriodicTask(0.05, function(inst)
            if _G.AllPlayers[1] ~= nil then
                inst.Net_player1_name:set(_G.AllPlayers[1].name)
                local x, y, z = _G.AllPlayers[1].Transform:GetWorldPosition()
                inst.Net_player1_x:set(x)
                inst.Net_player1_z:set(z)
            end
            if _G.AllPlayers[2] ~= nil then
                inst.Net_player2_name:set(_G.AllPlayers[2].name)
                local x, y, z = _G.AllPlayers[2].Transform:GetWorldPosition()
                inst.Net_player2_x:set(x)
                inst.Net_player2_z:set(z)
            end
            if _G.AllPlayers[3] ~= nil then
                inst.Net_player3_name:set(_G.AllPlayers[3].name)
                local x, y, z = _G.AllPlayers[3].Transform:GetWorldPosition()
                inst.Net_player3_x:set(x)
                inst.Net_player3_z:set(z)
            end
            if _G.AllPlayers[4] ~= nil then
                inst.Net_player4_name:set(_G.AllPlayers[4].name)
                local x, y, z = _G.AllPlayers[4].Transform:GetWorldPosition()
                inst.Net_player4_x:set(x)
                inst.Net_player4_z:set(z)
            end
            if _G.AllPlayers[5] ~= nil then
                inst.Net_player5_name:set(_G.AllPlayers[5].name)
                local x, y, z = _G.AllPlayers[5].Transform:GetWorldPosition()
                inst.Net_player5_x:set(x)
                inst.Net_player5_z:set(z)
            end
            if _G.AllPlayers[6] ~= nil then
                inst.Net_player6_name:set(_G.AllPlayers[6].name)
                local x, y, z = _G.AllPlayers[6].Transform:GetWorldPosition()
                inst.Net_player6_x:set(x)
                inst.Net_player6_z:set(z)
            end
        end )
    end
end
AddPlayerPostInit(PPPostInit)